<template>
	<!-- <div class="row">
		<div class="col-2">
			<input
				id="num-expediente"
				type="text"
				class="form-control form-control-sm text-center"
				v-model="data.expediente.origen_exp"
				disabled="true"
			/>
		</div>
		<div class="col-1 text-center">-</div>
		<div class="col-3">
			<input
				id="num-expediente"
				type="text"
				placeholder="Número"
				class="form-control form-control-sm text-center"
				v-model="data.expediente.numero_exp"
				:disabled="disabled || data.isValidating"
			/>
		</div>
		<div class="col-1 text-center">/</div>
		<div class="col-2">
			<input
				id="num-expediente"
				type="text"
				placeholder="Año"
				class="form-control form-control-sm text-center"
				v-model="data.expediente.anios_exp"
				:disabled="disabled || data.isValidating"
			/>
		</div>
		<div class="col-1 text-center">-</div>
		<div class="col-2">
			<input
				id="num-expediente"
				type="text"
				placeholder="Alcance"
				class="form-control form-control-sm text-center"
				v-model="data.expediente.alcance"
				:disabled="disabled || data.isValidating"
			/>
		</div>
	</div> -->
	<div class="input-group form-control-sm">
		<input
			id="num-expediente"
			type="text"
			class="form-control text-center input-izq"
			v-model="data.expediente.origen_exp"
			disabled="true"
		/>
		<span class="input-group-text"> - </span>
		<input
			id="num-expediente"
			type="text"
			placeholder="Número"
			class="form-control text-center input-central"
			v-model="data.expediente.numero_exp"
			:disabled="disabled || data.isValidating"
		/>
		<span class="input-group-text"> / </span>
		<input
			id="num-expediente"
			type="text"
			placeholder="Año"
			class="form-control text-center input-central"
			v-model="data.expediente.anios_exp"
			:disabled="disabled || data.isValidating"
		/>
		<span class="input-group-text"> - </span>
		<input
			id="num-expediente"
			type="text"
			placeholder="Alcance"
			class="form-control text-center input-der"
			v-model="data.expediente.alcance"
			:disabled="disabled || data.isValidating"
		/>
	</div>
</template>

<script lang="ts">
import { reactive } from "vue";
import http from "@/http";
import shared from "@/shared.js";

const { urlApi, isEmpty, isNumber } = shared();

// ENTITIES
import type { ExpedienteInterface } from "@/entities/Expediente";
import { Expediente } from "@/entities/Expediente";

export default {
	name: "InputExpediente",
	props: {
		disabled: {
			type: Boolean,
			required: false,
			default: false,
		},
	},
	setup() {
		const data = reactive({
			isValidating: false,
			init: false as boolean,
			timer: 0 as number,
			expediente: {} as ExpedienteInterface,
		});

		function initForm() {
			data.expediente.id_caratula = 0;
			data.expediente.origen_exp = import.meta.env.VITE_FORM_LEGALES_EXP_ORIGEN;
			data.expediente.numero_exp = undefined;
			data.expediente.anios_exp = undefined;
			data.expediente.alcance = 0;
		}

		return {
			data,
			// METHODS
			initForm,
			isNumber,
		};
	},
	mounted() {
		this.initForm();
	},
	methods: {
		async getExpediente(): Promise<ExpedienteInterface | undefined> {
			var rtaExp: ExpedienteInterface | undefined = undefined;
			if (
				!isEmpty(this.data.expediente.numero_exp) &&
				!isEmpty(this.data.expediente.anios_exp) &&
				!isEmpty(this.data.expediente.alcance)
			) {
				this.data.isValidating = true;
				try {
					var response = await http.get(urlApi + "validarExpediente", {
						params: {
							origen_exp: this.data.expediente.origen_exp,
							numero_exp: this.data.expediente.numero_exp?.toString().trim(),
							anios_exp: this.data.expediente.anios_exp?.toString().trim(),
							alcance: this.data.expediente.alcance?.toString().trim(),
						},
					});
					if (response.data.status != "error") {
						rtaExp = new Expediente();
						rtaExp.origen_exp = this.data.expediente.origen_exp;
						rtaExp.numero_exp = this.data.expediente.numero_exp;
						rtaExp.anios_exp = this.data.expediente.anios_exp;
						rtaExp.alcance = this.data.expediente.alcance;
						rtaExp.id_caratula = parseInt(response.data.res.id_caratula);
					}
				} catch (error) {
					console.log(error);
				}
				this.data.isValidating = false;
			}
			return rtaExp;
		},
	},
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.input-izq {
	border-right: 0px !important;
	border-left-color: #ced4da !important;
	/* border-top-left-radius: 1px !important;
	border-bottom-left-radius: 1px !important; */
	border-start-start-radius: 50px !important;
	border-radius: 0px !important;
	border-top: 1px solid #ced4da !important;
	border-bottom: 1px solid #ced4da !important;
}
.input-central {
	border-right: 0px !important;
	border-left: 0px !important;
	border-radius: 0px !important;
	border-top: 1px solid #ced4da !important;
	border-bottom: 1px solid #ced4da !important;
}
.input-der {
	border-left: 0px !important;
	border-right-color: #ced4da !important;
	border-radius: 0px !important;
	border-top: 1px solid #ced4da !important;
	border-bottom: 1px solid #ced4da !important;
}
</style>
